#include "gui.h"

GtkWidget *main_window;
GtkWidget *charts_window;
GtkWidget *observations_runs_treeview;
GtkWidget *meteors_treeview;

GtkWidget *observer_code_entry;
GtkWidget *site_code_entry;
GtkWidget *date_entry;
GtkWidget *field_alpha_entry;
GtkWidget *field_delta_entry;

GtkWidget *edit_next_run_cell_button;	  
GtkWidget *edit_previous_run_cell_button;
GtkWidget *edit_next_meteor_cell_button; 
GtkWidget *edit_previous_meteor_cell_button;        

GtkWidget *statusbar;
gboolean statusbar_init_flag; /* wheter the statbar was initialized */

void corrida_quit( GtkDialog *dialog,
		   gint arg1,
		   gpointer user_data )
{
  if ( arg1 == GTK_RESPONSE_OK ) {
    extern gboolean statusbar_init_flag;

    statusbar_init_flag = FALSE; /* statbar is off */

    gtk_main_quit ();
  } else {
    ; /* do nothing */
  }
}

void corrida_confirm_quit( GtkWidget *widget,
			   gpointer  callback_data)
{
  if ( internal_data_get_edition_stat () == INTERNAL_DATA_EDITED ) {
    GtkWidget *dialog;
    extern GtkWidget *main_window;

    dialog = gtk_message_dialog_new (GTK_WINDOW (main_window),
				     GTK_DIALOG_MODAL
				     | GTK_DIALOG_DESTROY_WITH_PARENT, 
				     GTK_MESSAGE_WARNING,
				     GTK_BUTTONS_OK_CANCEL,
				     "Form was changed!\nAre you sure you want to quit?");

    g_signal_connect (G_OBJECT (dialog), "response",
		      G_CALLBACK (corrida_quit), NULL);
    g_signal_connect_after (G_OBJECT (dialog), "response",
			    G_CALLBACK (gtk_widget_destroy), GTK_OBJECT (dialog));
    
    gtk_widget_show (dialog);
  }
  else {
    corrida_quit (NULL, GTK_RESPONSE_OK, NULL);
  }
}

GtkWidget *create_menu_bar( void )
{
  /* menu bar
   *  +--file
   *  |   +--new
   *  |   +--open
   *  |   +--save
   *  |   +------------separator
   *  |   +--export
   *  |   +--preview
   *  |   +------------separator
   *  |   +--quit
   *  |
   *  +--help
   *      +--help
   *  |   +------------separator
   *      +--about
   */  
      
  GtkWidget *menu_bar;
  GtkWidget *root_menu;
  GtkWidget *menu;
  GtkWidget *menu_item;

  menu_bar = gtk_menu_bar_new ();

  /* create file menu */
  menu = gtk_menu_new ();

  /* create new item */
  menu_item = gtk_menu_item_new_with_label ("New");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (new_form_cb), NULL);
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create open item */
  menu_item = gtk_menu_item_new_with_label ("Open...");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (open_form_cb), NULL);
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create save item */
  menu_item = gtk_menu_item_new_with_label ("Save...");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (save_form_cb), NULL);
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create separator */
  menu_item = gtk_separator_menu_item_new ();
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create export item */
  menu_item = gtk_menu_item_new_with_label ("Export...");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (export_form_cb), NULL);
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create preview export item */
  menu_item = gtk_menu_item_new_with_label ("Export preview");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (export_preview_cb), NULL);
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create separator */
  menu_item = gtk_separator_menu_item_new ();
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create quit itme */
  menu_item = gtk_menu_item_new_with_label ("Quit");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (corrida_confirm_quit), NULL); 
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create root menu */
  root_menu = gtk_menu_item_new_with_label ("File");
  gtk_menu_shell_append (GTK_MENU_SHELL (menu_bar), root_menu);
  gtk_widget_show (root_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu);

  /* create help menu */
  menu = gtk_menu_new ();

  /* create help item */
  menu_item = gtk_menu_item_new_with_label ("Help...");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (menubar_help_clicked_cb), NULL);
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* create separator */
  menu_item = gtk_separator_menu_item_new ();
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* creat about item */
  menu_item = gtk_menu_item_new_with_label ("About...");
  g_signal_connect (G_OBJECT (menu_item), "activate",
		    G_CALLBACK (menubar_about_clicked_cb), NULL);
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
  gtk_widget_show (menu_item);

  /* creat root menu */
  root_menu = gtk_menu_item_new_with_label ("Help");
  gtk_menu_shell_append (GTK_MENU_SHELL (menu_bar), root_menu);
  gtk_widget_show (root_menu);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu);
      
  return menu_bar;
}

GtkWidget *create_toolbar( void )
{
  /* +--------------------------------------------+
   * |toolbar                                     |
   * | +----++----++----+ | +----++----+ | +----+ |
   * | |icon||icon||icon| | |icon||icon| | |icon| |
   * | +----++----++----+ | +----++----+ | +----+ |
   * +--------------------------------------------+
   */

  GtkWidget *toolbar;
  GtkWidget *icon;

  toolbar = gtk_toolbar_new ();

  /* new form button */
  icon = gtk_image_new_from_stock (GTK_STOCK_NEW, 
				   GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
			   NULL, "New form", NULL,
			   icon, G_CALLBACK (new_form_cb), NULL);
  /* open form button */
  icon = gtk_image_new_from_stock (GTK_STOCK_OPEN,
				   GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
			   NULL, "Open form", NULL,
			   icon, G_CALLBACK (open_form_cb), NULL);

  /* save form button */
  icon = gtk_image_new_from_stock (GTK_STOCK_SAVE,
				   GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
			   NULL, "Save form", NULL,
			   icon, G_CALLBACK (save_form_cb), NULL);

  /* space */
  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  /* export form button */
  icon = gtk_image_new_from_stock (GTK_STOCK_CONVERT,
				   GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
			   NULL, "Export form", NULL,
			   icon, G_CALLBACK (export_form_cb), NULL);

  /* preview export button */
  icon = gtk_image_new_from_stock (GTK_STOCK_FIND,
				   GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
			   NULL, "Export preview", NULL,
			   icon, G_CALLBACK (export_preview_cb), NULL); 

  /* space */
  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  /* quit corrida button */
  icon = gtk_image_new_from_stock (GTK_STOCK_QUIT,
				   GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_append_item (GTK_TOOLBAR (toolbar),
			   NULL, "Quit", NULL,
			   icon, GTK_SIGNAL_FUNC (corrida_confirm_quit), NULL); 

  return toolbar;
}

GtkWidget *create_observation( void )
{
  GtkWidget *observation;
  GtkWidget *table;
  GtkWidget *label;
  extern GtkWidget *observer_code_entry;
  extern GtkWidget *site_code_entry;
  extern GtkWidget *date_entry;
  extern GtkWidget *field_alpha_entry;
  extern GtkWidget *field_delta_entry;

  /* +---------------------+
   * |observation (frame)  |
   * | +-----------------+ |
   * | |table (6x2)      | |
   * | | +-----+ +-----+ | |
   * | | |label| |entry| | |
   * | | +-----+ +-----+ | |
   * | | +-----+ +-----+ | |
   * | | |label| |entry| | |
   * | | +-----+ +-----+ | |
   * | | +-----+ +-----+ | |
   * | | |label| |entry| | |
   * | | +-----+ +-----+ | |
   * | | +-------------+ | |
   * | | |label        | | |
   * | | +-------------+ | |
   * | | +-----+ +-----+ | |
   * | | |label| |entry| | |
   * | | +-----+ +-----+ | |
   * | | +-----+ +-----+ | |
   * | | |label| |entry| | |
   * | | +-----+ +-----+ | |
   * | +-----------------+ |
   * +---------------------+
   */

  /* observation (frame) */
  observation = gtk_frame_new ("Observation");

  table = gtk_table_new (3, 2, FALSE);
  gtk_container_set_border_width (GTK_CONTAINER (table), 
				  GUI_BORDER_SIZE_SMALL);
  gtk_container_add (GTK_CONTAINER (observation), table);
  gtk_widget_show (table);

  /* labels & entries */
  label = gtk_label_new ("Observer code:");
  gtk_table_attach_defaults (GTK_TABLE (table), label,
			     0, 1, 0, 1);
  gtk_widget_show (label);

  observer_code_entry = gtk_entry_new ();
  g_signal_connect (G_OBJECT (observer_code_entry), "cut-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (observer_code_entry), "delete-from-cursor",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (observer_code_entry), "activate",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (observer_code_entry), "paste-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (observer_code_entry), "toggle-overwrite",
		    G_CALLBACK (entry_edited_cb), NULL);
  gtk_entry_set_max_length (GTK_ENTRY (observer_code_entry), 5);
  gtk_table_attach_defaults (GTK_TABLE (table), observer_code_entry,
			     1, 2, 0, 1);
  gtk_widget_show (observer_code_entry);
 
  label = gtk_label_new ("Site code:");
  gtk_table_attach_defaults (GTK_TABLE (table), label,
			     0, 1, 1, 2);
  gtk_widget_show (label);

  site_code_entry = gtk_entry_new ();
  g_signal_connect (G_OBJECT (site_code_entry), "cut-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (site_code_entry), "delete-from-cursor",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (site_code_entry), "activate",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (site_code_entry), "paste-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (site_code_entry), "toggle-overwrite",
		    G_CALLBACK (entry_edited_cb), NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), site_code_entry,
			     1, 2, 1, 2);
  gtk_widget_show (site_code_entry);

  label = gtk_label_new ("Date (dd/dd mm yy):");
  gtk_table_attach_defaults (GTK_TABLE (table), label,
			     0, 1, 2, 3);
  gtk_widget_show (label);

  date_entry = gtk_entry_new ();
  g_signal_connect (G_OBJECT (date_entry), "cut-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (date_entry), "delete-from-cursor",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (date_entry), "activate",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (date_entry), "paste-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (date_entry), "toggle-overwrite",
		    G_CALLBACK (entry_edited_cb), NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), date_entry,
			     1, 2, 2, 3);
  gtk_widget_show (date_entry);

  label = gtk_label_new ("Center of the observed field:");
  gtk_table_attach_defaults (GTK_TABLE (table), label,
			     0, 2, 3, 4);
  gtk_widget_show (label);

  label = gtk_label_new ("Alpha (h m):");
  gtk_table_attach_defaults (GTK_TABLE (table), label,
			     0, 1, 4, 5);
  gtk_widget_show (label);

  field_alpha_entry = gtk_entry_new ();
  g_signal_connect (G_OBJECT (field_alpha_entry), "cut-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_alpha_entry), "delete-from-cursor",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_alpha_entry), "activate",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_alpha_entry), "paste-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_alpha_entry), "toggle-overwrite",
		    G_CALLBACK (entry_edited_cb), NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), field_alpha_entry,
			     1, 2, 4, 5);
  gtk_widget_show (field_alpha_entry);

  label = gtk_label_new ("Delta (d m):");
  gtk_table_attach_defaults (GTK_TABLE (table), label,
			     0, 1, 5, 6);
  gtk_widget_show (label);

  field_delta_entry = gtk_entry_new ();
  g_signal_connect (G_OBJECT (field_delta_entry), "cut-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_delta_entry), "delete-from-cursor",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_delta_entry), "activate",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_delta_entry), "paste-clipboard",
		    G_CALLBACK (entry_edited_cb), NULL);
  g_signal_connect (G_OBJECT (field_delta_entry), "toggle-overwrite",
		    G_CALLBACK (entry_edited_cb), NULL);
  gtk_table_attach_defaults (GTK_TABLE (table), field_delta_entry,
			     1, 2, 5, 6);
  gtk_widget_show (field_delta_entry);

  return observation;
}

void clear_observation( void )
{
  extern GtkWidget *observer_code_entry;
  extern GtkWidget *site_code_entry;
  extern GtkWidget *date_entry;
  extern GtkWidget *field_alpha_entry;
  extern GtkWidget *field_delta_entry;

  gtk_entry_set_text (GTK_ENTRY (observer_code_entry), "\0");
  gtk_entry_set_text (GTK_ENTRY (site_code_entry), "\0");
  gtk_entry_set_text (GTK_ENTRY (date_entry), "\0");
  gtk_entry_set_text (GTK_ENTRY (field_alpha_entry), "\0");
  gtk_entry_set_text (GTK_ENTRY (field_delta_entry), "\0");  
}

GtkWidget *create_observation_runs_list( void )
{
  /* +----------------------------------------------+
   * |observation_runs_list (frame)                 |
   * | +------------------------------------------+ |
   * | |vbox                                      | |
   * | | +--------------------------------------+ | |
   * | | |scrolled_window                       | | |
   * | | | +----------------------------------+ | | |
   * | | | |treeview                          | | | |
   * | | | +----------------------------------+ | | |
   * | | +--------------------------------------+ | |
   * | | +--------------------------------------+ | |
   * | | |hbox                                  | | |
   * | | | +------+ +------+ +------+  +------+ | | |
   * | | | |button| |button| |button|  |button| | | |
   * | | | |s 0x0 | |      | |      |  |s 0x0 | | | |
   * | | | +------+ +------+ +------+  +------+ | | |
   * | | +--------------------------------------+ | |
   * | +------------------------------------------+ |
   * +----------------------------------------------+
   */

  GtkWidget *observation_runs_list;
  GtkWidget *vbox;
  GtkWidget *scrolled_window;
  GtkWidget *treeview;
  GtkWidget *hbox;
  GtkWidget *button;

  extern GtkWidget *edit_next_run_cell_button;	  
  extern GtkWidget *edit_previous_run_cell_button;

  observation_runs_list = gtk_frame_new ("Obserwation runs list");
  
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (observation_runs_list), vbox);
  gtk_widget_show (vbox);

  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_set_border_width (GTK_CONTAINER (scrolled_window),
				  GUI_BORDER_SIZE_SMALL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_AUTOMATIC,
				  GTK_POLICY_ALWAYS);
  gtk_box_pack_start (GTK_BOX (vbox), scrolled_window, 
		      TRUE, TRUE, 0);
  gtk_widget_show (scrolled_window);

  treeview = create_observation_runs_list_treeview ();
  g_signal_connect (G_OBJECT (treeview), "key-press-event",
		    G_CALLBACK (treeview_key_press_cb), 
		    (gpointer) OBSERVATIONS_RUNS_TREEVIEW);
  gtk_container_add (GTK_CONTAINER(scrolled_window),
		     treeview);
  gtk_widget_show (treeview);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 
				  GUI_BORDER_SIZE_SMALL);
  gtk_box_pack_start (GTK_BOX (vbox), hbox,
		      FALSE, FALSE, 0);
  gtk_widget_show (hbox);

  button = gtk_button_new_with_label ("Edit next cell"); /* virtual button */
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) EDIT_NEXT_RUN_CELL_BUTTON);
  gtk_widget_set_size_request (button, 0, 0);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  edit_next_run_cell_button = button; /* button known globally */
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Add run");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) ADD_RUN_BUTTON);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Remove run");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) REMOVE_RUN_BUTTON);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Edit previous cell"); /* virtual button */
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) EDIT_PREVIOUS_RUN_CELL_BUTTON);
  gtk_widget_set_size_request (button, 0, 0);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  edit_previous_run_cell_button = button; /* button known globally */
  gtk_widget_show (button);

  return observation_runs_list;
}

GtkWidget *create_observation_runs_list_treeview( void )
{
  extern GtkWidget *observations_runs_treeview;
  extern GArray *observations_runs_list;
  GtkTreeModel *model;

  model = create_observations_runs_model (observations_runs_list);
  observations_runs_treeview = gtk_tree_view_new_with_model (model);
  g_object_unref (model);
  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (observations_runs_treeview), TRUE);
  add_columns_to_observations_runs (GTK_TREE_VIEW (observations_runs_treeview));

  return observations_runs_treeview;
}

GtkTreeModel *create_observations_runs_model( GArray *runs )
{
  gint iter;
  GtkListStore *store;
  GtkTreeIter tree_iter;

  /* create list store */
  store = gtk_list_store_new (RUNS_LIST_N_COLUMNS,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING);
  
  /* add data to the list store */
  for (iter = 0; iter < runs->len; iter++) {
    corrida_observation_run run_record;
    
    run_record = g_array_index (runs, corrida_observation_run, iter);
    gtk_list_store_append (store, &tree_iter);
    gtk_list_store_set (store, &tree_iter,
			RUNS_LIST_COLUMN_BEGIN, run_record.time_begin,
			RUNS_LIST_COLUMN_END, run_record.time_end,
			RUNS_LIST_COLUMN_TEFF, run_record.teff,
			RUNS_LIST_COLUMN_LM, run_record.lm,
			RUNS_LIST_COLUMN_F, run_record.f,
			RUNS_LIST_COLUMN_LAST_MET, run_record.last_meteor,
			-1);
  }

  return GTK_TREE_MODEL (store);
}

void add_columns_to_observations_runs( GtkTreeView *treeview )
{
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GtkTreeModel *model = gtk_tree_view_get_model (treeview);

  /* column for time begin */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_observations_runs_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (observations_runs_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) RUNS_LIST_COLUMN_BEGIN);
  column = gtk_tree_view_column_new_with_attributes ("Begin",
						     renderer,
						     "text",
						     RUNS_LIST_COLUMN_BEGIN,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 60,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for time end */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_observations_runs_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (observations_runs_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) RUNS_LIST_COLUMN_END);
  column = gtk_tree_view_column_new_with_attributes ("End",
						     renderer,
						     "text",
						     RUNS_LIST_COLUMN_END,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 60,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for teff */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_observations_runs_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (observations_runs_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) RUNS_LIST_COLUMN_TEFF);
  column = gtk_tree_view_column_new_with_attributes ("Teff",
						     renderer,
						     "text",
						     RUNS_LIST_COLUMN_TEFF,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 50,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for lm */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_observations_runs_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (observations_runs_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) RUNS_LIST_COLUMN_LM);
  column = gtk_tree_view_column_new_with_attributes ("LM",
						     renderer,
						     "text",
						     RUNS_LIST_COLUMN_LM  ,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 50,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for f */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_observations_runs_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (observations_runs_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) RUNS_LIST_COLUMN_F);
  column = gtk_tree_view_column_new_with_attributes ("F",
						     renderer,
						     "text",
						     RUNS_LIST_COLUMN_F,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 50,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for last meteor */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_observations_runs_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (observations_runs_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) RUNS_LIST_COLUMN_LAST_MET);
  column = gtk_tree_view_column_new_with_attributes ("Last meteor",
						     renderer,
						     "text",
						     RUNS_LIST_COLUMN_LAST_MET,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 70,
		NULL);
  gtk_tree_view_append_column (treeview, column);
}

GtkWidget *create_meteors_list( void )
{
  /* +----------------------------------------------+
   * |meteors_list (frame)                          |
   * | +------------------------------------------+ |
   * | |vbox                                      | |
   * | | +--------------------------------------+ | |
   * | | |scrolled_window                       | | |
   * | | | +----------------------------------+ | | |
   * | | | |treeview                          | | | |
   * | | | +----------------------------------+ | | |
   * | | +--------------------------------------+ | |
   * | | +--------------------------------------+ | |
   * | | |hbox                                  | | |
   * | | | +------+ +------+ +------+  +------+ | | |
   * | | | |button| |button| |button|  |button| | | |
   * | | | |s 0x0 | |      | |      |  |s 0x0 | | | |
   * | | | +------+ +------+ +------+  +------+ | | |
   * | | +--------------------------------------+ | |
   * | +------------------------------------------+ |
   * +----------------------------------------------+
   */

  GtkWidget *meteors_list;
  GtkWidget *vbox;
  GtkWidget *scrolled_window;
  GtkWidget *treeview;
  GtkWidget *hbox;
  GtkWidget *button;

  extern GtkWidget *edit_next_meteor_cell_button; 
  extern GtkWidget *edit_previous_meteor_cell_button;        

  meteors_list = gtk_frame_new ("Meteors list");

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (meteors_list), vbox);
  gtk_widget_show (vbox);

  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_set_border_width (GTK_CONTAINER (scrolled_window),
				  GUI_BORDER_SIZE_SMALL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_AUTOMATIC,
				  GTK_POLICY_ALWAYS);
  gtk_box_pack_start (GTK_BOX (vbox), scrolled_window,
		      TRUE, TRUE, 0);
  gtk_widget_show (scrolled_window);

  treeview = create_meteors_list_treeview ();
  g_signal_connect (G_OBJECT (treeview), "key-press-event",
		    G_CALLBACK (treeview_key_press_cb), 
		    (gpointer) METEORS_TREEVIEW);
  gtk_container_add (GTK_CONTAINER (scrolled_window),
		     treeview);
  gtk_widget_show (treeview);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox),
				  GUI_BORDER_SIZE_SMALL);
  gtk_box_pack_start (GTK_BOX (vbox), hbox,
		      FALSE, FALSE, 0);
  gtk_widget_show (hbox);

  button = gtk_button_new_with_label ("Edit next cell"); /* virtual button */
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) EDIT_NEXT_METEOR_CELL_BUTTON);
  gtk_widget_set_size_request (button, 0, 0);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  edit_next_meteor_cell_button = button; /* button known globally */
  gtk_widget_show (button);
 
  button = gtk_button_new_with_label ("Add meteor");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) ADD_METEOR_BUTTON);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Remove meteor");
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) REMOVE_METEOR_BUTTON);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  gtk_widget_show (button);

  button = gtk_button_new_with_label ("Edit previous cell"); /* virtual button */
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (button_clicked_cb), 
		    (gpointer) EDIT_PREVIOUS_METEOR_CELL_BUTTON);
  gtk_widget_set_size_request (button, 0, 0);
  gtk_box_pack_start (GTK_BOX (hbox), button,
		      FALSE, FALSE, 0);
  edit_previous_meteor_cell_button = button; /* button known globally */
  gtk_widget_show (button);
 
  return meteors_list;
}

GtkWidget *create_meteors_list_treeview( void )
{
  extern GtkWidget *meteors_treeview;
  extern GArray *meteors_list;
  GtkTreeModel *model;

  model = create_meteors_list_model (meteors_list);
  meteors_treeview = gtk_tree_view_new_with_model (model);
  g_object_unref (model);
  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (meteors_treeview), TRUE);
  add_columns_to_meteors_list (GTK_TREE_VIEW (meteors_treeview));

  return meteors_treeview;
}

GtkTreeModel *create_meteors_list_model( GArray *meteors )
{
  gint iter;
  GtkListStore *store;
  GtkTreeIter tree_iter;

  /* create list store */
  store = gtk_list_store_new (METEORS_LIST_N_COLUMNS,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING);

  /* add data to the list store */
  for ( iter = 0; iter < meteors->len; iter++ ) {
    corrida_meteor_record met_record;

    met_record = g_array_index (meteors, corrida_meteor_record, iter);
    gtk_list_store_append (store, &tree_iter);
    gtk_list_store_set (store, &tree_iter,
			METEORS_LIST_COLUMN_NO, met_record.no,
			METEORS_LIST_COLUMN_TIME, met_record.time,
			METEORS_LIST_COLUMN_MAGNITUDE, met_record.mag,
			METEORS_LIST_COLUMN_VELOCITY, met_record.vel,
			METEORS_LIST_COLUMN_STREAM, met_record.stream,
			-1);
  }

  return GTK_TREE_MODEL (store);
}

void add_columns_to_meteors_list( GtkTreeView *treeview )
{
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GtkTreeModel *model = gtk_tree_view_get_model (treeview);

  /* column for meteor number */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_meteors_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (meteors_list_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) METEORS_LIST_COLUMN_NO);
  column = gtk_tree_view_column_new_with_attributes ("No.",
						     renderer,
						     "text",
						     METEORS_LIST_COLUMN_NO,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 50,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for meteor time */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_meteors_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (meteors_list_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) METEORS_LIST_COLUMN_TIME);
  column = gtk_tree_view_column_new_with_attributes ("Time",
						     renderer,
						     "text",
						     METEORS_LIST_COLUMN_TIME,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 60,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for meteor magnitude */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_meteors_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (meteors_list_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) METEORS_LIST_COLUMN_MAGNITUDE);
  column = gtk_tree_view_column_new_with_attributes ("Mag.",
						     renderer,
						     "text",
						     METEORS_LIST_COLUMN_MAGNITUDE,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 50,
		NULL);
  gtk_tree_view_append_column (treeview, column);
  
  /* column for meteor velocity */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_meteors_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (meteors_list_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) METEORS_LIST_COLUMN_VELOCITY);
  column = gtk_tree_view_column_new_with_attributes ("Vel.",
						     renderer,
						     "text",
						     METEORS_LIST_COLUMN_VELOCITY,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 45,
		NULL);
  gtk_tree_view_append_column (treeview, column);

  /* column for meteor stream */
  renderer = gtk_cell_renderer_text_new ();
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (current_meteors_cell_set_cb), NULL);
  g_signal_connect (G_OBJECT (renderer), "edited",
		    G_CALLBACK (meteors_list_cell_edit), model);
  g_object_set (G_OBJECT (renderer), 
		"editable", TRUE,
		NULL);
  g_object_set_data (G_OBJECT (renderer), "column", (gint *) METEORS_LIST_COLUMN_STREAM);
  column = gtk_tree_view_column_new_with_attributes ("Stream",
						     renderer,
						     "text",
						     METEORS_LIST_COLUMN_STREAM,
						     NULL);
  g_object_set (G_OBJECT (column),
		"resizable", TRUE,
		"min-width", 60,
		NULL);
  gtk_tree_view_append_column (treeview, column);
}

GtkWidget *create_statusbar( void )
{
  extern GtkWidget *statusbar;
  extern gboolean statusbar_init_flag;

  statusbar = gtk_statusbar_new ();
 
  statusbar_init_flag = TRUE; /* status bar initialized */

  return statusbar;
}

void corrida_error_box( GtkWindow *window,
			char *message )
{
  GtkWidget *error_dialog;
  
  error_dialog = gtk_message_dialog_new (GTK_WINDOW (window),
					 GTK_DIALOG_DESTROY_WITH_PARENT,
					 GTK_MESSAGE_ERROR,
					 GTK_BUTTONS_CLOSE, 
					 "%s", message);
   g_signal_connect_swapped (GTK_OBJECT (error_dialog), "response",
			     G_CALLBACK (gtk_widget_destroy),
			     GTK_OBJECT (error_dialog));
   gtk_widget_show (error_dialog);
}

void add_observation_run_record ()
{
  /* add new record to GArray */
  add_observation_run_record_to_garray ();
  /* add new record to treeview */
  add_observation_run_record_to_treeview ();

  corrida_printf ("observation run record added");
}

void add_observation_run_record_to_treeview( void )
{
  /* this function should be invoked only by 'add_observation_run_record ()'
   * after call of 'add_observation_run_record_to_garray ()'
   */
  
  extern GArray *observations_runs_list;
  extern GtkWidget *observations_runs_treeview;
  corrida_observation_run run_record;
  gint iter;
  GtkTreeIter tree_iter;
  GtkTreeModel *model;

  iter = observations_runs_list->len - 1; /* iter points on last element
					   * of this array
					   */

  model = gtk_tree_view_get_model (GTK_TREE_VIEW (observations_runs_treeview));
  
  run_record = g_array_index (observations_runs_list,
			      corrida_observation_run,
			      iter);
  gtk_list_store_append (GTK_LIST_STORE (model), &tree_iter);
  gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
		      RUNS_LIST_COLUMN_BEGIN, run_record.time_begin,
		      RUNS_LIST_COLUMN_END, run_record.time_end,
		      RUNS_LIST_COLUMN_TEFF, run_record.teff,
		      RUNS_LIST_COLUMN_LM, run_record.lm,
		      RUNS_LIST_COLUMN_F, run_record.f,
		      RUNS_LIST_COLUMN_LAST_MET, run_record.last_meteor,
		      -1);
}

void remove_observation_run_record( void )
{
  extern GArray *observations_runs_list;
  extern GtkWidget *observations_runs_treeview;
  GtkTreeModel *model;
  GtkTreeSelection *selection ;
  GtkTreeIter tree_iter;
  
  model = gtk_tree_view_get_model (GTK_TREE_VIEW (observations_runs_treeview));
  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (observations_runs_treeview));

  if (gtk_tree_selection_get_selected (selection, NULL, &tree_iter)) {
    gint iter;
    GtkTreePath *path;

    path = gtk_tree_model_get_path (model, &tree_iter);
    iter = gtk_tree_path_get_indices (path)[0];

    /* remove selected record from GAaray */
    remove_observation_run_record_from_garray (iter);

    /* remove selected record from treeview */
    remove_observation_run_record_from_treeview (GTK_LIST_STORE (model), 
						 &tree_iter);

    gtk_tree_path_free (path);

    corrida_printf ("observation run record removed");
  }
}

void remove_observation_run_record_from_treeview( GtkListStore *list_store, 
						  GtkTreeIter  *tree_iter )
{
  gtk_list_store_remove (list_store, tree_iter);
}

void clear_observations_runs_treeview( void )
{
  extern GArray *observations_runs_list;
  extern GtkWidget *observations_runs_treeview;
  GtkTreeModel *model;
  GtkTreeIter tree_iter;
  GtkTreePath *path;
  gint it;

  model = gtk_tree_view_get_model (GTK_TREE_VIEW (observations_runs_treeview));
  path = gtk_tree_path_new_from_string ("0");

  while ( gtk_tree_model_get_iter (model, &tree_iter, path) ) { 
    remove_observation_run_record_from_treeview(GTK_LIST_STORE (model),
						&tree_iter);
  }
  gtk_tree_path_free (path);
}

void refresh_observations_runs_treeview( void )
{
  extern GArray *observations_runs_list;
  extern GtkWidget *observations_runs_treeview;
  corrida_observation_run obs_run;
  gint iter;
  GtkTreeIter tree_iter;
  GtkTreeModel *model;
  gchar string[MAX_CORRIDA_STRLEN];
  
  model = gtk_tree_view_get_model (GTK_TREE_VIEW (observations_runs_treeview));

  for ( iter = 0; iter < observations_runs_list->len; iter++ ) {
    obs_run = g_array_index (observations_runs_list,
			     corrida_observation_run,
			     iter);

    gtk_list_store_append (GTK_LIST_STORE (model), &tree_iter);

    /* add record to the list store */
    sprintf (string, "%s", obs_run.time_begin);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			RUNS_LIST_COLUMN_BEGIN, string, -1);
    
    sprintf (string, "%s", obs_run.time_end);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			RUNS_LIST_COLUMN_END, string, -1);

    sprintf (string, "%s", obs_run.teff);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			RUNS_LIST_COLUMN_TEFF, string, -1);

    sprintf (string, "%s", obs_run.lm);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			RUNS_LIST_COLUMN_LM, string, -1);

    sprintf (string, "%s", obs_run.f);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			RUNS_LIST_COLUMN_F, string, -1);

    sprintf (string, "%s", obs_run.last_meteor);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			RUNS_LIST_COLUMN_LAST_MET, string, -1);
  }
}

void add_meteor_record( void )
{
  /* add new record to GArray */
  add_meteor_record_to_garray ();
  /* add new record to treeview */
  add_meteor_record_to_treeview ();

  corrida_printf ("meteor record added");
}

void add_meteor_record_to_treeview( void )
{
  /* this function should be invoked onyl by add_meteor_record ()'
   * after call of 'add_meteor_record_to_garray ()'
   */

  extern GArray *meteors_list;
  extern GtkWidget *meteors_treeview;
  corrida_meteor_record met_record;
  gint iter;
  GtkTreeIter tree_iter;
  GtkTreeModel *model;

  iter = meteors_list->len - 1; /* iter points on last element
				 * of this array
				 */

  model = gtk_tree_view_get_model (GTK_TREE_VIEW (meteors_treeview));

  met_record = g_array_index (meteors_list,
			      corrida_meteor_record,
			      iter);
  gtk_list_store_append (GTK_LIST_STORE (model), &tree_iter);
  gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
		      METEORS_LIST_COLUMN_NO, met_record.no,
		      METEORS_LIST_COLUMN_TIME, met_record.time,
		      METEORS_LIST_COLUMN_MAGNITUDE, met_record.mag,
		      METEORS_LIST_COLUMN_VELOCITY, met_record.vel,
		      METEORS_LIST_COLUMN_STREAM, met_record.stream,
		      -1);
}

void remove_meteor_record( void )
{
  extern GArray *meteors_list;
  extern GtkWidget *meteors_treeview;
  GtkTreeModel *model;
  GtkTreeSelection *selection;
  GtkTreeIter tree_iter;

  model = gtk_tree_view_get_model (GTK_TREE_VIEW (meteors_treeview));
  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (meteors_treeview));
  
  if (gtk_tree_selection_get_selected (selection, NULL, &tree_iter)) {
    gint iter;
    GtkTreePath *path;
    
    path = gtk_tree_model_get_path (model, &tree_iter);
    iter = gtk_tree_path_get_indices (path)[0];

    /* remove selected record from GArray */
    remove_meteor_record_from_garray (iter);
    
    /* remove selected record from treeview */
    remove_meteor_record_from_treeview (GTK_LIST_STORE (model), 
					&tree_iter);
    gtk_tree_path_free (path);

    corrida_printf ("meteor record removed");
  }
}

void clear_meteors_treeview( void )
{
  extern GArray *meteors_list;
  extern GtkWidget *meteors_treeview;
  GtkTreeModel *model;
  GtkTreeIter tree_iter;
  GtkTreePath *path;
  gint it;

  model = gtk_tree_view_get_model (GTK_TREE_VIEW (meteors_treeview));
  path = gtk_tree_path_new_from_string ("0");

  while ( gtk_tree_model_get_iter (model, &tree_iter, path) ) {
    remove_observation_run_record_from_treeview(GTK_LIST_STORE (model),
                                                &tree_iter);
  }
  gtk_tree_path_free (path);
}

void refresh_meteors_treeview( void )
{
  extern GArray *meteors_list;
  extern GtkWidget *meteors_treeview;
  corrida_meteor_record met_rec;
  gint iter;
  GtkTreeIter tree_iter;
  GtkTreeModel *model;
  gchar string[MAX_CORRIDA_STRLEN];

  model = gtk_tree_view_get_model (GTK_TREE_VIEW (meteors_treeview));

  for ( iter = 0; iter < meteors_list->len; iter++ ) {
    met_rec = g_array_index (meteors_list,
			     corrida_meteor_record,
			     iter);

    gtk_list_store_append (GTK_LIST_STORE (model), &tree_iter);

    /* add record to the list store */
    sprintf (string, "%s", met_rec.no);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			METEORS_LIST_COLUMN_NO, string, -1);

    sprintf (string, "%s", met_rec.time);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			METEORS_LIST_COLUMN_TIME, string, -1);

    sprintf (string, "%s", met_rec.mag);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			METEORS_LIST_COLUMN_MAGNITUDE, string, -1);

    sprintf (string, "%s", met_rec.vel);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			METEORS_LIST_COLUMN_VELOCITY, string, -1);

    sprintf (string, "%s", met_rec.stream);
    gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter,
			METEORS_LIST_COLUMN_STREAM, string, -1);
  }
}

void remove_meteor_record_from_treeview( GtkListStore *list_store, 
					 GtkTreeIter  *tree_iter )
{
  gtk_list_store_remove (list_store, tree_iter);
}

void edit_cell( gpointer data )
{
  extern GArray *observations_runs_list;
  extern GArray *meteors_list;
  extern GtkWidget *observations_runs_treeview;
  extern GtkWidget *meteors_treeview;

  GtkTreeView *treeview;
  GtkTreePath *treepath;
  GtkTreeViewColumn *focus_column;
  GtkCellRendererText *current_cell;
  int *which_button;
  gint *column;
  gint next_row;
  gchar *path_string;
  gint next_column;

  which_button = (int *) &data;
  switch (*which_button) {
  case EDIT_NEXT_RUN_CELL_BUTTON:
    treeview = GTK_TREE_VIEW (observations_runs_treeview);
    current_cell = current_observations_runs_cell_get_cb ();
    break;

  case EDIT_PREVIOUS_RUN_CELL_BUTTON:
    treeview = GTK_TREE_VIEW (observations_runs_treeview);
    current_cell = current_observations_runs_cell_get_cb ();
    break;
    
  case EDIT_NEXT_METEOR_CELL_BUTTON:
    treeview = GTK_TREE_VIEW (meteors_treeview);
    current_cell = current_meteors_cell_get_cb ();
    break;

  case EDIT_PREVIOUS_METEOR_CELL_BUTTON:
    treeview = GTK_TREE_VIEW (meteors_treeview);
    current_cell = current_meteors_cell_get_cb ();
    break;
  }

  /* set the appropriate cell being edited */
  if (current_cell != NULL) {
    switch (*which_button) {
    case EDIT_NEXT_RUN_CELL_BUTTON:
      gtk_tree_view_get_cursor (GTK_TREE_VIEW (treeview),
				&treepath,
				&focus_column);
      column = g_object_get_data (G_OBJECT (current_cell), "column");

      path_string = gtk_tree_path_to_string (treepath);
      next_row = atoi (path_string);

      next_column = GPOINTER_TO_INT (column) + 1;
      if ( !(next_column < RUNS_LIST_N_COLUMNS) ) {
	next_column = 0;
	next_row++;
      }

      if (next_row < observations_runs_list->len) { /* procced only if it is not out of list */
	sprintf (path_string, "%d", next_row);

	treepath = gtk_tree_path_new_from_string (path_string);
	focus_column = gtk_tree_view_get_column (GTK_TREE_VIEW (treeview),
						 next_column);
	
	gtk_tree_view_set_cursor (treeview,
				  treepath,
				  focus_column,
				  TRUE);
      }
      break;

    case EDIT_PREVIOUS_RUN_CELL_BUTTON:
      gtk_tree_view_get_cursor (GTK_TREE_VIEW (treeview),
				&treepath,
				&focus_column);
      column = g_object_get_data (G_OBJECT (current_cell), "column");

      path_string = gtk_tree_path_to_string (treepath);
      next_row = atoi (path_string);

      next_column = GPOINTER_TO_INT (column) - 1;
      if ( next_column < 0 ) {
	next_column = RUNS_LIST_N_COLUMNS - 1;
	next_row--;
      }

      if (next_row >= 0) { /* procced only if it is not out of list */
	sprintf (path_string, "%d", next_row);
	
	treepath = gtk_tree_path_new_from_string (path_string);
	focus_column = gtk_tree_view_get_column (GTK_TREE_VIEW (treeview),
					       next_column);

	gtk_tree_view_set_cursor (treeview,
				  treepath,
				  focus_column,
				  TRUE);
      }
      break;

    case EDIT_NEXT_METEOR_CELL_BUTTON:
      gtk_tree_view_get_cursor (GTK_TREE_VIEW (treeview),
				&treepath,
				&focus_column);
      column = g_object_get_data (G_OBJECT (current_cell), "column");
      
      path_string = gtk_tree_path_to_string (treepath);
      next_row = atoi (path_string);

      next_column = GPOINTER_TO_INT (column) + 1;
      if ( !(next_column < METEORS_LIST_N_COLUMNS) ) {
	next_column = 0;
	next_row++;
      }

      if (next_row < meteors_list->len) { /* procced only if it is not out of list */
	sprintf (path_string, "%d", next_row);

	treepath = gtk_tree_path_new_from_string (path_string);
	focus_column = gtk_tree_view_get_column (GTK_TREE_VIEW (treeview),
						 next_column);
	
	gtk_tree_view_set_cursor (treeview,
				  treepath,
				  focus_column,
				  TRUE);
      }
      break;
    
    case EDIT_PREVIOUS_METEOR_CELL_BUTTON:
      gtk_tree_view_get_cursor (GTK_TREE_VIEW (treeview),
				&treepath,
				&focus_column);
      column = g_object_get_data (G_OBJECT (current_cell), "column");

      path_string = gtk_tree_path_to_string (treepath);
      next_row = atoi (path_string);

      next_column = GPOINTER_TO_INT (column) - 1;
      if ( next_column < 0 ) {
	next_column = METEORS_LIST_N_COLUMNS - 1;
	next_row--;
      }

      if (next_row >=0 ) { /* procced only if it is not out of list */
	sprintf (path_string, "%d", next_row);

	treepath = gtk_tree_path_new_from_string (path_string);
	focus_column = gtk_tree_view_get_column (GTK_TREE_VIEW (treeview),
						 next_column);
	
	gtk_tree_view_set_cursor (treeview,
				  treepath,
				  focus_column,
				  TRUE);
      }
      break;
    }
  }
}

void statusbar_printf( char *message)
{
  extern GtkWidget *statusbar;
  extern gboolean statusbar_init_flag; /* wheter the statbar was initialized */
  static gchar last_message[MAX_CORRIDA_STRLEN] = "\0";
  static guint last_context_id;

  /* process if status bar is initialized */
  if (statusbar_init_flag == TRUE) {

    /* pop last message if exist */
    if ( strcmp (last_message, "\0") != 0 )
      gtk_statusbar_pop (GTK_STATUSBAR (statusbar), last_context_id);
    
    strcpy (last_message, message);
    last_context_id = gtk_statusbar_get_context_id (GTK_STATUSBAR (statusbar),
						    last_message);
    gtk_statusbar_push (GTK_STATUSBAR (statusbar),
			last_context_id,
			last_message);
  }
		      
}

void erease_form( void )
{
  /* clear text entries */
  clear_observation ();

  /* clear treeviews */
  clear_observations_runs_treeview ();
  clear_charts_meteors_treeview ();
  clear_meteors_treeview ();
  
  /* clear garrays */
  clear_observations_runs_garray ();
  clear_meteors_garray ();
  clear_charts_meteors_garray ();
  
  internal_data_set_edition_stat (INTERNAL_DATA_NOT_EDITED);

  refresh_chart ();
}

/* gui_init: init application gui */
int corrida_gui_init( int  *argc,
		    char ***argv )
{
  /* 
   * MAIN WINDOW WIDGETS 
   */
  extern GtkWidget *main_window;
  GtkWidget *main_window_vbox;
  GtkWidget *menubar;
  GtkWidget *toolbar;
  GtkWidget *observation;
  GtkWidget *maps_vpaned;
  GtkWidget *observation_runs_list;
  GtkWidget *meteors_list;
  GtkWidget *statusbar;

  /* 
   * CHARTS WINDOW WIDGETS 
   */
  extern GtkWidget *charts_window;
  GtkWidget *charts_window_hbox;
  GtkWidget *charts_vpaned;
  extern GtkWidget *charts_notebook;
  GtkWidget *charts_tools;
  GtkWidget *charts_meteors_list;

  GdkPixbuf *corrida_logo_pixbuf;
  gchar logo_path[MAX_CORRIDA_STRLEN];

  corrida_printf ("initializing corrida gui...");
  
  gtk_init (argc, argv);
  setlocale (LC_ALL, "C"); /* we don't need localization */
  
  /* 
   *       CREATE MAIN WINDOW
   * +------------------------------+
   * |main_window_vbox              |
   * | +--------------------------+ |		     
   * | |menu_bar                  | |		     
   * | +--------------------------+ |		     
   * | +--------------------------+ |		     
   * | |toolbar                   | |                 
   * | +--------------------------+ |                 
   * | +--------------------------+ |
   * | |observation               | |
   * | +--------------------------+ |
   * | +--------------------------+ |
   * | |maps_vpaned               | |
   * | | +----------------------+ | |
   * | | |observation_runs_list | | |
   * | | +----------------------+ | |
   * | | +----------------------+ | |
   * | | |meteors_list          | | |
   * | | +----------------------+ | |
   * | +--------------------------+ |
   * | +--------------------------+ |
   * | |statusbar                 | |
   * | +--------------------------+ |
   * +------------------------------+
   *
   */

  /* main_window */
  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_signal_connect (G_OBJECT (main_window), "delete_event",
		    G_CALLBACK (corrida_confirm_quit), NULL);
  g_signal_connect (G_OBJECT (main_window), "destroy_event",
		    G_CALLBACK (corrida_confirm_quit), NULL);
  gtk_window_set_title (GTK_WINDOW (main_window), APPLICATION_NAME);
  gtk_window_set_default_size (GTK_WINDOW (main_window), 350, 550);
  sprintf (logo_path, "%scorrida_logo_small.png", internal_data_get_sharedir_path ());
  corrida_logo_pixbuf = gdk_pixbuf_new_from_file (logo_path, NULL);
  gtk_window_set_icon (GTK_WINDOW (main_window), corrida_logo_pixbuf);
  
  /* main_window_vbox */
  main_window_vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (main_window), main_window_vbox);
  gtk_widget_show (main_window_vbox);

  /* menu bar */
  menubar = create_menu_bar ();
  gtk_box_pack_start (GTK_BOX (main_window_vbox), menubar,
		      FALSE, FALSE, 0);
  gtk_widget_show (menubar);

  /* toolbar */
  toolbar = create_toolbar ();
  gtk_box_pack_start (GTK_BOX (main_window_vbox), toolbar,
		      FALSE, FALSE, 0);
  gtk_widget_show (toolbar);

  /* observation */
  observation = create_observation ();
  gtk_container_set_border_width (GTK_CONTAINER (observation),
				  GUI_BORDER_SIZE_SMALL);
  gtk_box_pack_start (GTK_BOX (main_window_vbox), observation,
		      FALSE, FALSE, 0);
  gtk_widget_show (observation);

  /* maps vpaned */
  maps_vpaned = gtk_vpaned_new ();
  gtk_paned_set_position (GTK_PANED (maps_vpaned), 150); /* FIXME: position */
  gtk_box_pack_start (GTK_BOX (main_window_vbox), maps_vpaned,
		      TRUE, TRUE, 0);
  gtk_widget_show (maps_vpaned);

  /* observation runs list */
  observation_runs_list = create_observation_runs_list ();
  gtk_container_set_border_width (GTK_CONTAINER (observation_runs_list), 
				  GUI_BORDER_SIZE_SMALL);

  gtk_paned_add1 (GTK_PANED (maps_vpaned), observation_runs_list);
  gtk_widget_show (observation_runs_list);

  /* meteors list */
  meteors_list = create_meteors_list ();
  gtk_container_set_border_width (GTK_CONTAINER (meteors_list), 
				  GUI_BORDER_SIZE_SMALL);
  gtk_paned_add2 (GTK_PANED (maps_vpaned), meteors_list);
  gtk_widget_show (meteors_list);

  /* statusbar */
  statusbar = create_statusbar ();
  gtk_container_set_border_width (GTK_CONTAINER (statusbar),
				  GUI_BORDER_SIZE_SMALL);
  gtk_box_pack_start (GTK_BOX (main_window_vbox), statusbar,
		      FALSE, FALSE, 0);
  gtk_widget_show (statusbar);

  /* 
   *               CHARTS WINDOW 
   * +-------------------------------------------+
   * |charts_window_hbox                         |
   * | +-----------------------+ +-------------+ |
   * | |charts_vpaned          | |charts_tools | |
   * | | +-------------------+ | |             | |
   * | | |charts_notebook    | | |             | |
   * | | +-------------------+ | |	       | |
   * | | +-------------------+ | |	       | |
   * | | |charts_meteors_list| | |	       | |
   * | | +-------------------+ | |	       | |
   * | +-----------------------+ +-------------+ |       
   * +-------------------------------------------+
   *
   */

   /* charts window */
  charts_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_signal_connect (G_OBJECT (charts_window), "delete_event",
		    G_CALLBACK (corrida_confirm_quit), NULL);
  g_signal_connect (G_OBJECT (charts_window), "destroy_event",
		    G_CALLBACK (corrida_confirm_quit), NULL);
  gtk_window_set_title (GTK_WINDOW (charts_window), "charts");
  gtk_window_set_default_size (GTK_WINDOW (charts_window), 700, 600);
  gtk_window_set_icon (GTK_WINDOW (charts_window), corrida_logo_pixbuf);

  /* charts window hbox */
  charts_window_hbox = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (charts_window), charts_window_hbox);
  gtk_widget_show (charts_window_hbox);

  /* charts_vpaned_window */
  charts_vpaned = gtk_vpaned_new ();
  gtk_paned_set_position (GTK_PANED (charts_vpaned), 450); /* FIXME: position */
  gtk_box_pack_start (GTK_BOX (charts_window_hbox), charts_vpaned,
		      TRUE, TRUE, 0);
  gtk_widget_show (charts_vpaned);

  /* charts notebook */
  charts_notebook = create_charts_notebook ();
  gtk_container_set_border_width (GTK_CONTAINER (charts_notebook),
				  GUI_BORDER_SIZE_SMALL);
  gtk_paned_add1 (GTK_PANED (charts_vpaned), charts_notebook);
  gtk_widget_show (charts_notebook);

  /* charts meteor list */
  charts_meteors_list = create_charts_meteors_list ();
  gtk_container_set_border_width (GTK_CONTAINER (charts_meteors_list),
				  GUI_BORDER_SIZE_SMALL);
  gtk_paned_add2 (GTK_PANED (charts_vpaned), charts_meteors_list);
  gtk_widget_show (charts_meteors_list);

  /* charts tools */
  charts_tools = create_charts_tools ();
  gtk_container_set_border_width (GTK_CONTAINER (charts_tools),
				  GUI_BORDER_SIZE_SMALL);
  gtk_widget_set_size_request (charts_tools, 150, 490); /* FIXME: sizes... */
  gtk_box_pack_start (GTK_BOX (charts_window_hbox), charts_tools,
		      FALSE, FALSE, 0);
  gtk_widget_show (charts_tools);

  /* show windows */
  gtk_widget_show (charts_window);
  gtk_widget_show (main_window);

  return 0; /* succeful */
}

/* gui_start: starting corrida_gui */
int corrida_gui_start ()
{
  corrida_printf ("gui started");

  /* We need this timeout function for refreshing chart in active notebook */
  gtk_timeout_add (1000, check_if_notebook_was_switched, NULL);
  
  gtk_main ();
}

void destroy_file_selector( GtkButton *button,
			    gpointer data )
{
  gtk_widget_destroy ((GtkWidget *)data);
}
