#include "gui.h"

void menubar_about_clicked_cb( GtkMenuItem *menuitem,
			       gpointer user_data )

{
  extern *main_window;
  GtkWidget *dialog;
  GtkWidget *vbox;
  GtkWidget *image;
  GtkWidget *label;
  gchar string[100];

  gchar logo_path[MAX_CORRIDA_STRLEN];

  PangoFontDescription *font_desc;

  dialog = gtk_dialog_new_with_buttons ("About corrida",
					GTK_WINDOW (main_window),
					GTK_DIALOG_DESTROY_WITH_PARENT,
					"Ok",
					GTK_RESPONSE_NONE,
					NULL);
  g_signal_connect_swapped (G_OBJECT (dialog), "response", 
			    G_CALLBACK (gtk_widget_destroy),
			    GTK_OBJECT (dialog));
  g_signal_connect_swapped (G_OBJECT (dialog), "destroy", 
			    G_CALLBACK (gtk_widget_destroy),
			    G_OBJECT (dialog));

  vbox = GTK_DIALOG (dialog)->vbox;
  gtk_container_set_border_width (GTK_CONTAINER (vbox),
				  GUI_BORDER_SIZE_SMALL);

  sprintf (logo_path, "%scorrida_logo_medium_shadow.png", internal_data_get_sharedir_path ());
  image = gtk_image_new_from_file (logo_path);
  gtk_box_pack_start (GTK_BOX (vbox), image,
		      FALSE, FALSE, 0);
		      gtk_widget_show (image);

  sprintf (string, "Corrida v. %.2f",  CORRIDA_VER_NO);
  corrida_printf (string);
  label = gtk_label_new (string);
  font_desc = pango_font_description_from_string ("Bold 16");
  gtk_widget_modify_font (label, font_desc);
  gtk_box_pack_start (GTK_BOX (vbox), label,
		      FALSE, FALSE, 5);
  gtk_widget_show (label);

  sprintf (string, "Copyright %s by Michal Jurek", DEV_YEAR);
  label = gtk_label_new (string);
  gtk_box_pack_start (GTK_BOX (vbox), label,
		      FALSE, FALSE, 0);
  gtk_widget_show (label);

  label = gtk_label_new ("jurmcc@gmail.com");
  gtk_box_pack_start (GTK_BOX (vbox), label,
		      FALSE, FALSE, 5);
  gtk_widget_show (label);  

  gtk_widget_show (dialog);
}
