#include "gui.h"

GtkCellRendererText *current_observations_runs_cell = NULL;
GtkCellRendererText *current_meteors_cell = NULL;
static gint edition_status = CHARTS_EDITION_STATUS_NULL;
corrida_charts_meteor_record current_meteor;

void new_form_cb( GtkWidget *widget,
		  gpointer data )
{
  if ( internal_data_get_edition_stat () == INTERNAL_DATA_EDITED )
    create_new_form_window ();
  else 
    erease_form ();
}

void open_form_cb( GtkWidget *widget,
		   gpointer data )
{
  if ( internal_data_get_edition_stat () == INTERNAL_DATA_EDITED ) {
    confirm_open_form_window ();
  }
  else {
    create_open_form_window ();
  }
}

void save_form_cb( GtkWidget *widget,
		   gpointer data )
{
  create_save_form_window ();
}

void export_preview_cb( GtkWidget *widget,
			gpointer data )
{
  corrida_export_data export_data;

  export_data = create_export_data ();

  if ( export_data.stat == TRUE )
    create_export_preview_window (export_data);
}

void export_form_cb( GtkWidget *widget,
		     gpointer data )
{
  corrida_export_data export_data;

  export_data = create_export_data ();

  if ( export_data.stat == TRUE )
    create_export_form_window (export_data);
  
}

void export_form_cancel_pressed_cb( GtkButton *button,
				    gpointer data )
{
  gtk_widget_destroy (data);
}

void export_form_export_pressed_cb( GtkButton *button,
				    gpointer data )
{
  corrida_export_data *export_data;
  FILE *fp;
  gchar message[MAX_CORRIDA_STRLEN];
  gboolean stat = TRUE;

  export_data = (corrida_export_data *)data;

  /* export to file: heads */
  fp = fopen (export_data->heads_filename, "w");
  if ( fp != NULL ) {
    fprintf (fp, "%s", export_data->heads->str);
    fclose (fp);

    sprintf (message, "heads '%s' saved", export_data->heads_filename);
    corrida_printf (message);
  } else {
    sprintf (message, "ERROR: unable to open %s file for writing");
    corrida_printf (message);
    stat = FALSE;
  }

  /* export to file: coords */
  fp = fopen (export_data->coords_filename, "w");
  if ( fp != NULL ) {
    fprintf (fp, "%s", export_data->coords->str);
    fclose (fp);

    sprintf (message, "coords '%s' saved", export_data->coords_filename);
    corrida_printf (message);
  } else {
    sprintf (message, "ERROR: unable to open %s file for writing");
    corrida_printf (message);
    stat = FALSE;
  }

  /* export to file: notpl */
  fp = fopen (export_data->notpl_filename, "w");
  if ( fp != NULL ) {
    fprintf (fp, "%s", export_data->notpl->str);
    fclose (fp);
    
    sprintf (message, "notpl '%s' saved", export_data->notpl_filename);
    corrida_printf (message);
  } else {
    sprintf (message, "ERROR: unable to open %s file for writing");
    corrida_printf (message);
    stat = FALSE;
  }
  
  if ( stat == TRUE )
    corrida_printf ("files saved");
  else
    corrida_printf ("ERORR: files not sucessfully saved");
}

void menubar_help_clicked_cb( GtkMenuItem *menuitem,
			      gpointer user_data )
{
  /* FIXME: fork & exec we need here to run mozilla or sth */
}

void entry_edited_cb( GtkEntry *entry,
		      gpointer user_data)
{
  internal_data_set_edition_stat (INTERNAL_DATA_EDITED);
  printf ("FIXME: entry_edited_cb\n"); /* FIXME: remove this line */
}

void observations_runs_cell_edit( GtkCellRendererText *cell,
				  const gchar         *path_string,
				  gchar               *new_text,
				  gpointer             data )
{
  extern GtkWidget *main_window;
  extern GArray *observations_runs_list;
  extern GtkWidget *observations_runs_treeview;
  GtkTreeModel *model = (GtkTreeModel *) data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter tree_iter;
  gint *column;
  gint iter;
  gchar *old_text;
  int check_stat;

  column = g_object_get_data (G_OBJECT (cell), "column");
  gtk_tree_model_get_iter (model, &tree_iter, path);

  switch (GPOINTER_TO_INT (column)) {
  case RUNS_LIST_COLUMN_BEGIN:
    check_stat = check_string (new_text, CHECK_TIME);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (observations_runs_list, 
			     corrida_observation_run, 
			     iter).time_begin);
      g_array_index (observations_runs_list, 
		     corrida_observation_run, 
		     iter).time_begin = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
			  g_array_index (observations_runs_list, corrida_observation_run, iter).time_begin, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check TIME field you have typed.\nMore info on status bar.");
    }
    break;
  case RUNS_LIST_COLUMN_END:
    check_stat = check_string (new_text, CHECK_TIME);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (observations_runs_list, corrida_observation_run, iter).time_end);
      g_array_index (observations_runs_list, corrida_observation_run, iter).time_end = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
			  g_array_index (observations_runs_list, corrida_observation_run, iter).time_end, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check TIME field you have typed.\nMore info on status bar.");
    }
    break;
  case RUNS_LIST_COLUMN_TEFF:
    check_stat = check_string (new_text, CHECK_TEFF);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (observations_runs_list, corrida_observation_run, iter).teff);
      g_array_index (observations_runs_list, corrida_observation_run, iter).teff = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
			  g_array_index (observations_runs_list, corrida_observation_run, iter).teff, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check TEFF field you have typed.\nMore info on status bar.");
    }
    break;

  case RUNS_LIST_COLUMN_LM:
    check_stat = check_string (new_text, CHECK_MAG);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (observations_runs_list, corrida_observation_run, iter).lm);
      g_array_index (observations_runs_list, corrida_observation_run, iter).lm = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
			  g_array_index (observations_runs_list, corrida_observation_run, iter).lm, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check MAGNITUDE field you have typed.\nMore info on status bar.");
    }
    break;

  case RUNS_LIST_COLUMN_F:
    check_stat = check_string (new_text, CHECK_F);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (observations_runs_list, corrida_observation_run, iter).f);
      g_array_index (observations_runs_list, corrida_observation_run, iter).f = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
			  g_array_index (observations_runs_list, corrida_observation_run, iter).f, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check F factor field you have typed.\nMore info on status bar.");
    }
    break;

  case RUNS_LIST_COLUMN_LAST_MET:
    check_stat = check_string (new_text, CHECK_UINT);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (observations_runs_list, corrida_observation_run, iter).last_meteor);
      g_array_index (observations_runs_list, corrida_observation_run, iter).last_meteor = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
			  g_array_index (observations_runs_list, corrida_observation_run, iter).last_meteor, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check LAST METEOR field you have typed.\nMore info on status bar.");
    }
    break;
  }

  /* FIXME: block below is temporary */
  {
    extern GArray *observations_runs_list;
    print_data_from_runs_list ();
  }
}

void meteors_list_cell_edit( GtkCellRenderer *cell,
			     const gchar     *path_string,
			     gchar           *new_text,
			     gpointer         data)
{
  extern GtkWidget *main_window;
  extern GArray *meteors_list;
  GtkTreeModel *model = (GtkTreeModel *) data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter tree_iter;
  gint *column;
  gint iter;
  gchar *old_text;
  int check_stat;

  column = g_object_get_data (G_OBJECT (cell), "column");
  gtk_tree_model_get_iter (model, &tree_iter, path);

  switch (GPOINTER_TO_INT (column)) {
  case METEORS_LIST_COLUMN_NO:
    check_stat = check_string (new_text, CHECK_UINT);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (meteors_list, corrida_meteor_record, iter).no);
      g_array_index (meteors_list, corrida_meteor_record, iter).no = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
                          g_array_index (meteors_list, corrida_meteor_record, iter).no, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check METEOR NUMBER field you have typed.\nMore info on status bar.");
    }
    break;

  case METEORS_LIST_COLUMN_TIME:
    check_stat = check_string (new_text, CHECK_TIME);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (meteors_list, corrida_meteor_record, iter).time);
      g_array_index (meteors_list, corrida_meteor_record, iter).time = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
                          g_array_index (meteors_list, corrida_meteor_record, iter).time, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check METEOR TIME field you have typed.\nMore info on status bar.");
    }
    break; 

  case METEORS_LIST_COLUMN_MAGNITUDE:
    check_stat = check_string (new_text, CHECK_MAG);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (meteors_list, corrida_meteor_record, iter).mag);
      g_array_index (meteors_list, corrida_meteor_record, iter).mag = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
                          g_array_index (meteors_list, corrida_meteor_record, iter).mag, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check METEOR MAGNITUDE field you have typed.\nMore info on status bar.");
    }
    break;   

  case METEORS_LIST_COLUMN_VELOCITY:
    check_stat = check_string (new_text, CHECK_VEL);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (meteors_list, corrida_meteor_record, iter).vel);
      g_array_index (meteors_list, corrida_meteor_record, iter).vel = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
                          g_array_index (meteors_list, corrida_meteor_record, iter).vel, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check METEOR VELOCITY field you have typed.\nMore info on status bar.");
    }
    break;   

  case METEORS_LIST_COLUMN_STREAM:
    check_stat = check_string (new_text, CHECK_STREAM);
    if (check_stat == 0) {
      gtk_tree_model_get (model, &tree_iter, column, &old_text, -1);
      g_free (old_text);
      
      iter = gtk_tree_path_get_indices (path)[0];
      g_free (g_array_index (meteors_list, corrida_meteor_record, iter).stream);
      g_array_index (meteors_list, corrida_meteor_record, iter).stream = g_strdup (new_text);
      
      gtk_list_store_set (GTK_LIST_STORE (model), &tree_iter, column,
                          g_array_index (meteors_list, corrida_meteor_record, iter).stream, -1);
    } else {
      corrida_error_box (GTK_WINDOW (main_window), "Please check METEOR STREAM field you have typed.\nMore info on status bar.");
    }
    break;
  }

  /* FIXME: block below is temporary */
  {
    extern GArray *meteors_list;
    print_data_from_meteors_list ();
  }
}

void button_clicked_cb (GtkButton *button,
			gpointer   data)
{
  int *which_button;

  which_button = (int *) &data;

  internal_data_set_edition_stat (INTERNAL_DATA_EDITED);

  switch (*which_button) {
  case ADD_RUN_BUTTON:
    add_observation_run_record ();
    /* call below is probably temporary */
    print_data_from_runs_list ();
    break;

  case REMOVE_RUN_BUTTON:
    remove_observation_run_record ();
    /* call below is probably temporary */
    print_data_from_runs_list ();
    break;

  case ADD_METEOR_BUTTON:
    add_meteor_record ();
    /* call below is probably temporary */
    print_data_from_meteors_list (); 
    break;

  case REMOVE_METEOR_BUTTON:
    remove_meteor_record ();
    /* call below is probably temporary */
    print_data_from_meteors_list ();
    break;

  case EDIT_NEXT_RUN_CELL_BUTTON:
    edit_cell (data);
    break;

  case EDIT_PREVIOUS_RUN_CELL_BUTTON:
    edit_cell (data);
    break;

  case EDIT_NEXT_METEOR_CELL_BUTTON:
    edit_cell (data);
    break;
    
  case EDIT_PREVIOUS_METEOR_CELL_BUTTON:
    edit_cell (data);
    break;
  }
}

gint treeview_key_press_cb( GtkWidget   *widget,
			     GdkEventKey *event,
			     gpointer     data )
{
  extern GtkWidget *edit_next_run_cell_button;
  extern GtkWidget *edit_previous_run_cell_button;
  extern GtkWidget *edit_next_meteor_cell_button;
  extern GtkWidget *edit_previous_meteor_cell_button;
  
  gint *which_treeview = data;
  
  switch (event->keyval) {
  case GDK_Tab: /* do editing next cell */
    {
      switch (GPOINTER_TO_INT (which_treeview)) {
      case OBSERVATIONS_RUNS_TREEVIEW:
	gtk_widget_activate (edit_next_run_cell_button);
	break;
      case METEORS_TREEVIEW:
	gtk_widget_activate (edit_next_meteor_cell_button);
	break;
      }
      break;
    }
    
  case GDK_ISO_Left_Tab: /* do editing previous cell */
    {
      switch (GPOINTER_TO_INT (which_treeview)) {
      case OBSERVATIONS_RUNS_TREEVIEW:
	gtk_widget_activate (edit_previous_run_cell_button);
	break;
      case METEORS_TREEVIEW:
	gtk_widget_activate (edit_previous_meteor_cell_button);
	break;
      }
      break;
    }
  }
  
  return FALSE; /* let the signal being processed */
}

void current_observations_runs_cell_set_cb( GtkCellRendererText *cell,
					 const gchar         *path_string,
					 gchar               *new_text,
					 gpointer             data)
{
  extern GtkCellRendererText *current_observations_runs_cell;

  current_observations_runs_cell = cell;

}

GtkCellRendererText *current_observations_runs_cell_get_cb( void )
{
  extern GtkCellRendererText *current_observations_runs_cell;  

  return current_observations_runs_cell;
}

void current_meteors_cell_set_cb( GtkCellRendererText *cell,
				  const gchar         *path_string,
				  gchar               *new_text,
				  gpointer             data)
{
  extern GtkCellRendererText *current_meteors_cell;

  current_meteors_cell = cell;

}
GtkCellRendererText *current_meteors_cell_get_cb( void )
{
  extern GtkCellRendererText *current_meteors_cell;

  return current_meteors_cell;
}

void num_pad_button_clicked(GtkButton *button,
			    gpointer data)
{
  GtkWidget *entry = data;
  gint which_button;
  gchar entry_text[11];
  gint length;

  strcpy (entry_text, gtk_entry_get_text (GTK_ENTRY (entry))) ;
  length = strlen (entry_text);

  which_button = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (button),
						     "which_button"));
  switch (which_button) {
  case NUM_PAD_BUTTON_0:
    if (length < 10) {
      strcat (entry_text, "0");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_1:
    if (length < 10) {
      strcat (entry_text, "1");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_2:
    if (length < 10) {
      strcat (entry_text, "2");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_3:
    if (length < 10) {
      strcat (entry_text, "3");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_4:
    if (length < 10) {
      strcat (entry_text, "4");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_5:
    if (length < 10) {
      strcat (entry_text, "5");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_6:
    if (length < 10) {
      strcat (entry_text, "6");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_7:
    if (length < 10) {
      strcat (entry_text, "7");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_8:
    if (length < 10) {
      strcat (entry_text, "8");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_9:
    if (length < 10) {
      strcat (entry_text, "9");
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_DEL:
    if (length > 0) {
      entry_text[length-1] = '\0';
      gtk_entry_set_text (GTK_ENTRY (entry), entry_text);
    }
    break;

  case NUM_PAD_BUTTON_ENTER:
    /* FIXME: ... */
    printf ("Num pad enter clicked.\n");
    break;
  }
}

/* redraw the screen from the backing pixmap */
gint chart_expose_event( GtkWidget      *widget,
			 GdkEventExpose *event )
{
  gpointer which_pixbuf;
  gpointer which_pixmap;
  gpointer initialized;
  int it;
  
  initialized = g_object_get_data (G_OBJECT (widget), "initialized");

  if ( !(GPOINTER_TO_INT (initialized)) ) {
    which_pixbuf = g_object_get_data(G_OBJECT (widget), "which_pixbuf");

    which_pixmap = gdk_pixmap_new (widget->window,
				   widget->allocation.width,
				   widget->allocation.height,
				   -1);
    gdk_draw_pixbuf (which_pixmap, NULL, which_pixbuf,
		     0, 0, 0, 0, -1, -1, GDK_RGB_DITHER_NORMAL, 2, 2);
    gdk_draw_drawable (widget->window,
		       widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		       which_pixmap,
		       event->area.x, event->area.y,
		       event->area.x, event->area.y,
		       event->area.width, event->area.height);

    g_object_set_data (G_OBJECT (widget), "initialized", 
		       (gpointer)TRUE);
    g_object_set_data (G_OBJECT (widget), "which_pixmap", 
		       (gpointer)which_pixmap);
  } else {
    which_pixmap = g_object_get_data (G_OBJECT (widget), "which_pixmap");
    gdk_draw_drawable (widget->window,
		       widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		       which_pixmap,
		       event->area.x, event->area.y,
		       event->area.x, event->area.y,
		       event->area.width, event->area.height);
  }

  return FALSE;
}

gint chart_configure_event( GtkWidget         *widget,
			    GdkEventConfigure *event )
{
  return TRUE;
}

gint charts_style_check_button_pressed_cb( GtkWidget *widget,
					   gpointer   data )
{
  extern GtkWidget *coords_alpha_label;
  extern GtkWidget *coords_delta_label;
  gboolean state;

  state = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget));

  switch ( state ) {
  case 0:
    internal_data_set_charts_pointer_coords_style (SETTINGS_CHARTS_POINTER_COORDS_STYLE_DEGS);
					 
    break;

  case 1:
    internal_data_set_charts_pointer_coords_style (SETTINGS_CHARTS_POINTER_COORDS_STYLE_HOURS);
    break;
  }

  /* clear fileds in coords frame */
  gtk_label_set_text (GTK_LABEL (coords_alpha_label), "\0");
  gtk_label_set_text (GTK_LABEL (coords_delta_label), "\0");
}

/* callback for mouse clicked even on map */
gint chart_mouse_button_pressed_cb( GtkWidget      *widget,
				    GdkEventButton *event,
				    gpointer        data)
{
  /* which button was pressed */
  switch ( event->button ) {
  case 1: /* left mouse button was pressed */
    {
      extern gint edition_status;
      extern GtkWidget *meteor_position_entry[4];
      extern corrida_charts_meteor_record current_meteor;
      gint it;
      gchar string[100];
      
      current_meteor.map_no = GPOINTER_TO_INT (data);
      
      switch (edition_status) {
      case CHARTS_EDITION_STATUS_NULL:
	for ( it = 0; it < 4; it++ ) { /* clear and deactivate text entries */
	  gtk_editable_set_editable (GTK_EDITABLE (meteor_position_entry[it]),
				     FALSE);
	  gtk_entry_set_text (GTK_ENTRY (meteor_position_entry[it]), "\0");
	}
	
	current_meteor.car_begin.x = event->x;
	current_meteor.car_begin.y = event->y;
	car2eq (current_meteor.map_no,
		current_meteor.car_begin,
		&current_meteor.equ_begin);
	
	/* set meteor begin coords on entries */
	sprintf (string, "%6.2f", current_meteor.equ_begin.alpha);
	gtk_entry_set_text (GTK_ENTRY (meteor_position_entry[0]), string);
	sprintf (string, "%6.2f", current_meteor.equ_begin.delta);
	gtk_entry_set_text (GTK_ENTRY (meteor_position_entry[1]), string);
	
	edition_status = CHARTS_EDITION_STATUS_FIRST_POINT;
	break;
	
      case CHARTS_EDITION_STATUS_FIRST_POINT:
	current_meteor.car_end.x = event->x;
	current_meteor.car_end.y = event->y;
	car2eq (current_meteor.map_no,
		current_meteor.car_end,
		&current_meteor.equ_end);
	
	/* set meteor begin coords on entries */
	sprintf (string, "%6.2f", current_meteor.equ_end.alpha);
	gtk_entry_set_text (GTK_ENTRY (meteor_position_entry[2]), string);
	sprintf (string, "%6.2f", current_meteor.equ_end.delta);
	gtk_entry_set_text (GTK_ENTRY (meteor_position_entry[3]), string);
	
	draw_meteor(widget, current_meteor);
	
	edition_status = CHARTS_EDITION_STATUS_SECOND_POINT;
	break;
	
      case CHARTS_EDITION_STATUS_SECOND_POINT:
	
	/* FIXME: ... */
	
	break;
      }
    }
  case 2: /* middle mouse button was pressed */
    {
      ; /* nothing to do */

      break;
    }
  case 3: /* right mouse button was pressed */
    {
      ; /* nothing to do */

      break;
    }

  }
    
  return FALSE;
}

gint charts_accept_button_pressed_cb( GtkWidget      *widget,
				      gpointer        data)
{
  extern *charts_window;
  extern gint edition_status;
  extern corrida_charts_meteor_record current_meteor;
  extern GtkWidget *meteor_position_entry[4];
  extern GtkWidget *num_pad_entry;
  gint entries_stat = TRUE; /* entries ok */
  float entries_values[4];
  gchar entry_text[11];
  
  gint it;

  internal_data_set_edition_stat (INTERNAL_DATA_EDITED);

  switch (edition_status) {
  case CHARTS_EDITION_STATUS_NULL:
    for ( it = 0; it <4; it++) { /* checking and getting values from position entries */
      strcpy (entry_text,
	      gtk_entry_get_text (GTK_ENTRY (meteor_position_entry[it])));
      if (strlen (entry_text) < 1) { /* check lengths of entries */
	entries_stat = FALSE;
	corrida_printf ("no meteor position entered");
	corrida_error_box (GTK_WINDOW (charts_window), "Please point or enter meteor positions");
	break;
      }
      if (check_string (entry_text, CHECK_FLOAT) != 0) {
	entries_stat = FALSE;
	corrida_error_box (GTK_WINDOW (charts_window), "Please check the meteor position you entered. More info on status bar");
	break;
      }
      entries_values[it] = atof (entry_text);
    }

    /* now: get and get meteor number */
    if ( entries_stat == TRUE ) {
      strcpy (entry_text, 
	      gtk_entry_get_text (GTK_ENTRY (num_pad_entry)));
      if (strlen (entry_text) < 1) { /* check the length of met. num. entry */
	entries_stat = FALSE;
	corrida_printf ("no meteor number entered");
	corrida_error_box (GTK_WINDOW (charts_window), "Please enter meteor number\n");
      } else if ( check_string (entry_text, CHECK_UINT) != 0 ) { /* check format */
	entries_stat = FALSE;
	corrida_error_box (GTK_WINDOW (charts_window), "Please check the meteor number you entered. More info on statusbar");
      } 
    }

    if ( entries_stat == TRUE ) { /* all entries are ok */
      /* FIXME: add here meteors to list from entries and also draw it */
      /* FIXME: we need a new routine equ2car in gnomonic module... */
      printf ("adding meteor\n");
    }
    break;

  case CHARTS_EDITION_STATUS_FIRST_POINT:
    corrida_printf ("no endpoint of meteor specified");
    corrida_error_box (GTK_WINDOW (charts_window), "Please point end of meteor");
    break;

  case CHARTS_EDITION_STATUS_SECOND_POINT:
    /* first: get and check meteor number */
    strcpy (entry_text, 
	    gtk_entry_get_text (GTK_ENTRY (num_pad_entry)));
    if (strlen (entry_text) < 1) { /* check the length of met. num. entry */
      entries_stat = FALSE;
      corrida_printf ("no meteor number entered");
      corrida_error_box (GTK_WINDOW (charts_window), "Please enter meteor number\n");
    } else if ( check_string (entry_text, CHECK_UINT) != 0 ) { /* check format */
      entries_stat = FALSE;
      corrida_error_box (GTK_WINDOW (charts_window), "Please check the meteor number you entered. More info on statusbar");
    } else {
      current_meteor.met_no = atoi (entry_text);
      add_charts_meteor_record (current_meteor);
      refresh_chart ();
      
      /* clear entries and current meteor data */
      charts_clear_entries ();
      edition_status = CHARTS_EDITION_STATUS_NULL;
    }
    break;
  }
  
  return FALSE;
}

gint charts_clear_button_pressed_cb ( GtkWidget      *widget,
				      gpointer        data)
{
  extern gint edition_status;

  charts_clear_entries ();
  refresh_chart ();
  edition_status = CHARTS_EDITION_STATUS_NULL;
}

gint charts_remove_button_pressed_cb( GtkWidget      *widget,
				      gpointer        data )
{
  internal_data_set_edition_stat (INTERNAL_DATA_EDITED);

  remove_charts_meteor_record ();
  refresh_chart ();
  /* call_below is probably temporary */
  print_data_from_charts_meteors_list ();
}

gint charts_sort_button_pressed_cb( GtkWidget *widget,
				    gpointer   data )
{
  extern GArray *charts_meteors_list;

  internal_data_set_edition_stat (INTERNAL_DATA_EDITED);

  clear_charts_meteors_treeview ();
  sort_corrida_charts_meteors_in_garray (charts_meteors_list);
  refresh_charts_meteors_treeview ();

  /* call_below is probably temporary */
  print_data_from_charts_meteors_list ();
}

gint charts_notebook_switched_cb( GtkNotebook *notebook,
				  GtkNotebookPage *page,
				  guint page_num,
				  gpointer data)
{
  /* This function should do the same 
   * job as charts_clear_button_pressed_cb ().
   * We don't need here only refresh_chart ().
   */
  extern gint edition_status;

  charts_clear_entries ();
  edition_status = CHARTS_EDITION_STATUS_NULL;
}
