#include "internal_data.h"

static internal_data internal_data_container;

void internal_data_init( int  *argc,
			 char ***argv )
{
  extern internal_data internal_data_container;
  gchar path[MAX_CORRIDA_PATH_STRLEN];

  corrida_printf ("initalizing internal module...");

  /* FIXME: here we should get defaults settings in future... */
  
  /* now we set up only 'factory' settings */
  internal_data_container.edition_stat = INTERNAL_DATA_NOT_EDITED;

  internal_data_container.charts_pointer_corrida_style = SETTINGS_CHARTS_POINTER_COORDS_STYLE_DEGS;

  sprintf (path, "%s%s", _CORRIDA_PREFIX, "share/corrida/");
  internal_data_container.sharedir_path = g_strdup (path);

  sprintf (path, "%sVMDBSITE", 
	   internal_data_get_sharedir_path ());
  internal_data_container.vmdbsite_table_path = g_strdup (path);

  sprintf (path, "%sSOLAR_LONGITUDE_TABLE", 
	   internal_data_get_sharedir_path ());
  internal_data_container.solar_long_table_path = g_strdup (path);

  sprintf (path, "%s", 
	   internal_data_get_sharedir_path ());
  internal_data_container.charts_path = g_strdup (path);
}

void internal_data_set_edition_stat( gint edition_stat )
{
  extern internal_data internal_data_container;

  internal_data_container.edition_stat = edition_stat;
}

gint internal_data_get_edition_stat( void )
{
  extern internal_data internal_data_container;

  return internal_data_container.edition_stat;
}

gchar *internal_data_get_sharedir_path( void )
{
  extern internal_data internal_data_container;

  return internal_data_container.sharedir_path;
}

gchar *internal_data_get_vmdbsite_table_path( void )
{
  extern internal_data internal_data_container;

  return internal_data_container.vmdbsite_table_path;
}

gchar *internal_data_get_solar_long_table_path( void )
{
  extern internal_data internal_data_container;

  return internal_data_container.solar_long_table_path;
}

gchar *internal_data_get_charts_path( void )
{
  extern internal_data internal_data_container;

  return internal_data_container.charts_path;
}

gint internal_data_get_charts_pointer_coords_style( void )
{
  extern internal_data internal_data_container;

  return internal_data_container.charts_pointer_corrida_style;
}

void internal_data_set_charts_pointer_coords_style( gint style )
{
  extern internal_data internal_data_container;

  internal_data_container.charts_pointer_corrida_style = style;
}
