#ifndef _INTERNAL_DATA_H
#define _INTERNAL_DATA_H

#include <glib.h>
#include <stdio.h>

#include "console.h"

#define MAX_CORRIDA_PATH_STRLEN 1000

/* edition stats */
enum {
  INTERNAL_DATA_NOT_EDITED,
  INTERNAL_DATA_EDITED
};

enum {
  SETTINGS_CHARTS_POINTER_COORDS_STYLE_DEGS,
  SETTINGS_CHARTS_POINTER_COORDS_STYLE_HOURS
};

typedef struct _internal_data {
  gint edition_stat; /* whether the form was edited since last saving */

  gint charts_pointer_corrida_style; /* style of coords, degs or hous */

  gchar *sharedir_path;
  gchar *vmdbsite_table_path;   /* file with imo sites codes */
  gchar *solar_long_table_path; /* file with solar longitudes */
  gchar *charts_path;     /* directory with charts */
} internal_data;

void internal_data_init( int  *argc,
			 char ***argv );

void internal_data_set_edition_stat( gint edition_stat );
gint internal_data_get_edition_stat( void );

gchar *internal_data_get_sharedir_path( void );

void internal_data_set_vmdbsite_table_path( gchar *path ); /* FIXME: not implemented */
gchar *internal_data_get_vmdbsite_table_path( void );

void internal_data_set_solar_long_table_path( gchar *path ); /* FIXME: not implemented */
gchar *internal_data_get_solar_long_table_path( void );

void internal_data_set_charts_path( gchar *path ); /* FIXME: not implemented */
gchar *internal_data_get_charts_path( void );

gint internal_data_get_charts_pointer_coords_style( void );
void internal_data_set_charts_pointer_coords_style( gint style );

#endif 
