#ifndef _MISC_H
#define _MISC_H

#include <stdio.h>
#include <string.h>
#include <glib.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <locale.h>

#include "console.h"

#define CORRIDA_VER_NO 0.96
#define DEV_YEAR "2003, 2004, 2007"
#define MAX_EQU_DEGS_STRING  50
#define MAX_EQU_HOURS_STRING 50

typedef struct _cartesian_coords {
  float x;
  float y;
} cartesian_coords;

typedef struct _equatorial_coords_degs {
  float alpha;
  float delta;
} equatorial_coords_degs;

typedef struct _equatorial_coords_hours {
  int alpha_hour;
  int alpha_min;
  float alpha_sec;
  
  int delta_deg;
  float delta_min;
} equatorial_coords_hours;

void corrida_init( int  *argc,
		   char ***argv );

float corrida_deg2rad( float deg );
float corrida_rad2deg( float rad );

int equ_degs2equ_hours( equatorial_coords_degs eqcoords,
		 	equatorial_coords_hours *eqcoords_h );
char *equ_degs2equ_degs_string( equatorial_coords_degs eqcoords_d,
				char *string );
char *equ_degs2equ_hours_string( equatorial_coords_degs eqcoords_d,
				 char *string );
char *equ_hours2equ_hours_string( equatorial_coords_hours eqcoords_h,
				  char *string);

gdouble compute_angle( gdouble x, gdouble y );

int fgetl( FILE *file, gchar *line, int max_strlen );

void string_to_upper_case (char *string);

#endif
